<date-input-ft>
<div id="{divid}">
<input type="text" id="{fid}" name="{fname}" style="{style}" class="{css}" onclick="{fromdtp}" onkeyup="{checkfromdate}" data-type="date" placeholder="{placeholderFrom}" value="{valuef}" onfocus={focusFFunc} onblur={blurFFunc} onchange={changeFFunc} />
&nbsp;～&nbsp;
<input type="text" id="{tid}" name="{tname}" style="{style}" class="{css}" onclick="{todtp}" onkeyup="{checktodate}" data-type="date" placeholder="{placeholderTo}" value={valuet} onfocus={focusTFunc} onblur={blurTFunc} onchange={changeTFunc} />
<message tagid="{messageid}" msgstyle="{msgstyle}"></message>
</div>
<script>
	this.fid = opts.tagid + 'From';
	this.fname = (opts.name) ? opts.name + 'From' : opts.tagid + 'From';
	this.tid = opts.tagid + 'To';
	this.tname = (opts.name) ? opts.name + 'To' : opts.tagid + 'To';
	this.divid = opts.tagid + 'Div';
	this.messageid = opts.tagid + 'MessageDiv';
	this.maxlength = opts.maxlength;
	this.css = 'bakyel ' + (opts.css ? opts.css : '');
	this.style = 'ime-mode: disabled; ' + (opts.style ? opts.style : 'width:105px');
	this.minDate = opts.minDate ? opts.minDate : '1900/01/01';
	this.maxDate = opts.maxDate ? opts.maxDate : '2999/12/31';
	this.msgstyle = opts.msgstyle;
	this.placeholderFrom = (opts.placeholderFrom) ? opts.placeholderFrom : 'yyyy/mm/dd';
	this.placeholderTo = (opts.placeholderTo) ? opts.placeholderTo : 'yyyy/mm/dd';
	
	this.valuef = valueToDate(opts.valuef);
	this.valuet = valueToDate(opts.valuet);
	
	this.regptn = /((\d{4})\/(\d{2})\/(\d{2}))/;
	
	fromdtp(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		this.dtp(this.fid);
	}
	checkfromdate(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		this.checkdate(this.fid);
	}
	todtp(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		this.dtp(this.tid);
	}
	checktodate(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		this.checkdate(this.tid);
	}
	
	dtp(id) {
		if($('#' + id).val()) {
			var rtn = this.checkcal(id);
			if(rtn){
				$('#' + id).datepicker('show');
			}else{
				console.log('err001:' + $(this.messageid));
			}
		}
	}
	
	this.on('updated', function() {
		setDataObj(opts.tagid, opts);
		
		var datapickersetting = {
				numberOfMonths: 1,
				showCurrentAtPos: 0,
				dateFormat: 'yy/mm/dd',
				yearSuffix: common.datapickerYearSuffix,
				showMonthAfterYear: true,
				firstDay: 1,
				monthNames: [
					common.datapickerMonthName1
					, common.datapickerMonthName2
					, common.datapickerMonthName3
					, common.datapickerMonthName4
					, common.datapickerMonthName5
					, common.datapickerMonthName6
					, common.datapickerMonthName7
					, common.datapickerMonthName8
					, common.datapickerMonthName9
					, common.datapickerMonthName10
					, common.datapickerMonthName11
					, common.datapickerMonthName12],
				dayNames: [
					common.datapickerDayName1
					, common.datapickerDayName2
					, common.datapickerDayName3
					, common.datapickerDayName4
					, common.datapickerDayName5
					, common.datapickerDayName6
					, common.datapickerDayName7],
				dayNamesMin: [
					common.datapickerDayNameMin1
					, common.datapickerDayNameMin2
					, common.datapickerDayNameMin3
					, common.datapickerDayNameMin4
					, common.datapickerDayNameMin5
					, common.datapickerDayNameMin6
					, common.datapickerDayNameMin7],
				buttonImage: 'images/calendaricon.png',
				buttonText: common.datapickerButtonText,
				buttonImageOnly: true,
				showOn: 'button',
				nextText: '>', 
				prevText: '<',
				minDate: this.minDate,
				maxDate: this.maxDate
			};
		$('#' + this.fid).datepicker(datapickersetting);
 		$('#' + this.tid).datepicker(datapickersetting);
	}); 
	
	checkdate(id) {
		if($('#' + id).val()) {
			var rtn = this.checkcal(id);
			if(rtn){
				console.log('ok002:' + $(this.messageid));
			}else{
				console.log('err002:' + $(this.messageid));
			}
		}
	}

	checkcal(id) {
		var dateYmd = $('#' + id).val().split('/');
		return this.ValidDate(dateYmd[0],dateYmd[1],dateYmd[2]);
	}
	
	ValidDate(y,m,d) {
		dt = new Date(y,m-1,d);
		return(dt.getFullYear() == y && dt.getMonth() == m-1 && dt.getDate() == d);
	}

	// フォーカスin時の値を保持
	this._tmpValF = this.value;
	this._tmpValT = this.value;
	
	/**
	 * フォーカスin時の処理
	 */
	focusFFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		this._tmpValF = $('#' + this.fid).val();
	}
	
	/**
	 * フォーカスin時の処理
	 */
	focusTFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		this._tmpValT = $('#' + this.tid).val();
	}
	
	/**
	 * フォーカスout時の処理
	 */
	blurFFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		datefmt(this.fid);
		var aftVal = $('#' + this.fid).val();
		if (this._tmpValF != aftVal) {
			updFlg = true;
			$('#' + this.fid).attr('data-updflg', '1');
		}
	}
	
	/**
	 * フォーカスout時の処理
	 */
	blurTFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		datefmt(this.tid);
		var aftVal = $('#' + this.tid).val();
		if (this._tmpValT != aftVal) {
			updFlg = true;
			$('#' + this.tid).attr('data-updflg', '1');
		}
	}
	
	function datefmt(id){
		var tgtDate = $('#' + id).val();
		
		$('#' + id).val(valueToDate(tgtDate));

	}

	/**
	 * 入力値変更時の処理(From)
	 */
	changeFFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		if (opts.onchangeffunc != null) {
			opts.onchangeffunc();
		}
	}
	/**
	 * 入力値変更時の処理(To)
	 */
	changeTFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		if (opts.onchangetfunc != null) {
			opts.onchangetfunc();
		}
	}

	
	/**
	 * キーがデータ属性に使用するキーかどうか
	 */
	function isDataAttrKey(key) {
		return key.startsWith('data-');
	}
	
	/**
	 * データ属性を設定する
	 */
	function setDataObj(id, val, forcingFlg) {
		Object.keys(val).forEach(function(key) {
			if (isDataAttrKey(camelToSnake(key, '-')) || forcingFlg) {
				var v = val[key];
				if (typeof v === 'object') {
					setDataObj(id, v, true);
				} else {
					$('#' + id + 'From').attr(forcingFlg ? 'data-' + key : camelToSnake(key, '-'), v);
					$('#' + id + 'To').attr(forcingFlg ? 'data-' + key : camelToSnake(key, '-'), v);
				}
			}
		});
	}
</script>
</date-input-ft>
